/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.third.taihe;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface TaiheService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.third.taihe.TaiheService";
    String SERVICE_NAME = "com.ywt.gapi.third.taihe.TaiheService";

        /**
         * <pre>
         * 就诊ID||预约类型
         * </pre>
         */
    com.ywt.gapi.third.taihe.PhyPayOrderResponse phyPayOrder(com.ywt.gapi.third.taihe.PhyPayOrderRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.PhyPayOrderResponse> phyPayOrderAsync(com.ywt.gapi.third.taihe.PhyPayOrderRequest request){
        return CompletableFuture.completedFuture(phyPayOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void phyPayOrder(com.ywt.gapi.third.taihe.PhyPayOrderRequest request, StreamObserver<com.ywt.gapi.third.taihe.PhyPayOrderResponse> responseObserver){
        phyPayOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 登记号 非必须
         * </pre>
         */
    com.ywt.gapi.third.taihe.GetScheduleListResponse getScheduleList(com.ywt.gapi.third.taihe.GetScheduleListRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.GetScheduleListResponse> getScheduleListAsync(com.ywt.gapi.third.taihe.GetScheduleListRequest request){
        return CompletableFuture.completedFuture(getScheduleList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getScheduleList(com.ywt.gapi.third.taihe.GetScheduleListRequest request, StreamObserver<com.ywt.gapi.third.taihe.GetScheduleListResponse> responseObserver){
        getScheduleListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
